


#include "mbed.h"

#define TOP_PADDING             3
#define LEFT_PADDING            3
class ili9341_spi
{
    SPI& spi;
    DigitalOut cs;
     DigitalOut dc;
      DigitalOut rs;
    
  public:
   ili9341_spi(SPI& _spi, PinName _cs,PinName _dc,PinName _rs);
void select();
void deselect(); 
void draw_str(const char* str,uint8_t line); 
void draw_char(char ch,uint8_t rs,uint8_t line);  
void window (unsigned int x, unsigned int y, unsigned int w, unsigned int h);
void pixel(int x, int y, int color);
void vline(int x, int y0, int y1, int color);
void circle(int x0, int y0, int r, int color);
void fillcircle(int x0, int y0, int r, int color);
void fillrect(int x0, int y0, int x1, int y1, int color);
void wr_cmd(unsigned char cmd);
void wr_dat(unsigned char dat);
char rd_byte(unsigned char cmd);
int rd_32(unsigned char cmd);
int  Read_ID(void);
void tft_reset();

  private:
    PinName _CS_pin;
    PinName _SO_pin;
    PinName _SCK_pin;
    float _error;



};